#!/bin/bash

# После перезапуска контроллера, не доходят сообщения, если интернета нет
timeout 300 mosquitto_sub -t /devices/lastseen/controls/server/on -R -C 3 || exit 1

apt-cache policy iq-* > /tmp/iq-packages-info && mosquitto_pub -r -t /iq/bridge/upgrade/package_versions -q 2 -f /tmp/iq-packages-info
mosquitto_pub -r -t /iq/bridge/upgrade/bridge_version -q 2 -m "$(head -n 2 /mnt/data/etc/mosquitto/conf.d/bridge.conf)"
mosquitto_pub -r -t /devices/system/controls/bridges -q 2 -m "$(grep -a address /mnt/data/etc/mosquitto/conf.d/bridge.conf)"
mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "Ожидаем с $(date) // $(systemd --version | head -n 1)"
TYPE=$(mosquitto_sub -t /iq/bridge/upgrade -R -C 5)

mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "$(date) Обновляем..."

apt-get update && \
mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "Получены списки пакетов $(date)" || \
mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "Списки пакетов получены с ошибкой $(date)"

if [[ $TYPE == *"unsafe"* ]]; then
    mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "Обновление ПО через apt-get $(date)" || exit
    apt-get install -y --download-only iq-iqnergy-software-installer && \
    mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "Загружено ПО IQnergy $(date)" || exit

    apt-get install -y iq-iqnergy-software-installer && \
    mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "Установлено новое ПО $(date)" || exit

    apt-get -y clean
elif [[ $TYPE == *"safe"* ]]; then
    mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "Обновление ПО через unattended-upgrade $(date)" || exit
    unattended-upgrade && \
    mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "Установлено новое ПО $(date)" || exit
elif [[ $TYPE == *"upgrade"* ]]; then
    mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "Обновление всего $(date)" || exit
    apt-mark hold iq-do-upgrade
    export DEBIAN_FRONTEND=noninteractive
    apt upgrade -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" -y && sleep 10 && halt
else
    mosquitto_pub -t /iq/bridge/upgrade/status -q 1 -r -m "Команда не распознана $(date)" || exit
fi
